<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\Configuration;
use App\Models\User;

class ConfigurationPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any Configuration');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('view Configuration');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create Configuration');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('update Configuration');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('delete Configuration');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any Configuration');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('restore Configuration');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any Configuration');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('replicate Configuration');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder Configuration');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, Configuration $configuration): bool
    {
        return $user->checkPermissionTo('force-delete Configuration');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any Configuration');
    }
}
